package therapy_protocol

import (
	"net/http"

	rw "github.com/karincake/risoles"
	sf "github.com/karincake/semprit"

	// ua "github.com/karincake/tumpeng/auth/svc"

	e "simrs-vx/internal/domain/main-entities/therapy-protocol"
	erc "simrs-vx/internal/domain/references/common"
	u "simrs-vx/internal/use-case/main-use-case/therapy-protocol"

	d "github.com/karincake/dodol"

	pa "simrs-vx/internal/lib/auth"
)

type myBase struct{}

var O myBase

func (obj myBase) Create(w http.ResponseWriter, r *http.Request) {
	dto := e.CreateDto{}
	if res := rw.ValidateStructByIOR(w, r.Body, &dto); !res {
		return
	}
	res, err := u.Create(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) GetList(w http.ResponseWriter, r *http.Request) {
	dto := e.ReadListDto{}
	sf.UrlQueryParam(&dto, *r.URL)
	res, err := u.ReadList(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) GetDetail(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}
	dto := e.ReadDetailDto{}

	sf.UrlQueryParam(&dto, *r.URL)
	dto.Id = uint(id)
	res, err := u.ReadDetail(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) Update(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.UpdateDto{}
	if res := rw.ValidateStructByIOR(w, r.Body, &dto); !res {
		return
	}
	dto.Id = uint(id)
	res, err := u.Update(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) Delete(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.DeleteDto{}
	dto.Id = uint(id)
	res, err := u.Delete(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) Verify(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.VerifyDto{}
	if res := rw.ValidateStructByIOR(w, r.Body, &dto); !res {
		return
	}

	dto.Id = uint(id)
	authInfo, err := pa.GetAuthInfo(r)
	if err != nil {
		rw.WriteJSON(w, http.StatusUnauthorized, d.IS{"message": err.Error()}, nil)
	}

	dto.AuthInfo = *authInfo
	dto.Status_Code = erc.DVCVerified
	res, err := u.Verify(dto)
	rw.DataResponse(w, res, err)
}

func (obj myBase) Reject(w http.ResponseWriter, r *http.Request) {
	id := rw.ValidateInt(w, "id", r.PathValue("id"))
	if id <= 0 {
		return
	}

	dto := e.VerifyDto{}
	dto.Id = uint(id)
	authInfo, err := pa.GetAuthInfo(r)
	if err != nil {
		rw.WriteJSON(w, http.StatusUnauthorized, d.IS{"message": err.Error()}, nil)
	}
	dto.AuthInfo = *authInfo
	dto.Status_Code = erc.DVCRejected
	res, err := u.Verify(dto)
	rw.DataResponse(w, res, err)
}
